#define NULE 0
#define RULE 1
#define MULE 111111111

typedef struct NOiD_empty
{
	int id;
	int size;
	struct NOiD_empty * last;
	struct NOiD_empty * next;
} NOiD_empty;

NOiD_empty * NOiD_seg (void * noid_array, int noid_size)
{
	NOiD_empty * noid_new = (NOiD_empty*)(noid_array);
	noid_new->size = noid_size;
	noid_new->last = noid_new;
	noid_new->next = (NOiD_empty * ) (noid_array + sizeof(NOiD_empty));
		noid_new->next->id = MULE;
	noid_new->next->size = noid_size - sizeof(NOiD_empty) - sizeof(NOiD_empty);
	noid_new->next->next = (NOiD_empty * ) noid_array;
	noid_new->next->last = (NOiD_empty * ) noid_array;
		*(int*)((void*)noid_new + noid_new->size) = MULE;
	return noid_new;
}

void * NOiD_alloc (NOiD_empty * noid_array, int noid_size)
{
	if ((noid_size > noid_array->size - sizeof(NOiD_empty)-sizeof(int))||(noid_size < sizeof(NOiD_empty)))
	{	return NULE;	}
	/* find an empty space wide enought to place the allocation */
	NOiD_empty * noid_old = noid_array->next;
	while (noid_old->next != noid_array)
	{
		if (noid_old->size < noid_size)
		{	return NULE;	}
		noid_old->next;
	}
	if (noid_old == noid_array)
	{	return NULE;	}
	/* in the case it find one , that one will be used */
	void * noid_now = (void*)(noid_old);
	/* if there not enough space left after alocation to declare free space , it will be */
	/* added to the desired allocation */
	if (noid_old->size <= noid_size + sizeof(NOiD_empty) + sizeof(int))
	{
		noid_size = noid_old->size;
		noid_old->last->next = noid_old->next;
		noid_old->next->last = noid_old->last;
		*(int*)((void*)noid_old + noid_old->size ) = 0;
		*(int*)((void*)noid_old) = 0;
		*(int*)((void*)noid_old + sizeof(int)) = 0;
		*(int*)((void*)noid_old + sizeof(int)*2) = 0;
		*(int*)((void*)noid_old + sizeof(int)*3) = 0;
	}
	else
	{
	/*the most bizzard issue ever , if i add 1 to (noid_empty*) type , it add sizeof(noid_empty)*/
	/*then if i add sizeof(int) ,it add sizeof(int) multiplied by sizeof(noid_empty). weird....*/
		NOiD_empty * noid_new = (NOiD_empty*)((void*)noid_old + sizeof(int) + noid_size);
		noid_new->id = MULE;
		noid_new->size = noid_array->next->size - noid_size - sizeof(int);
		noid_new->last = noid_array->next->last;
		noid_new->next = noid_array->next->next;
		*(int*)((void*)noid_new + noid_new->size + sizeof(NOiD_empty)) = MULE;
		noid_array->next = noid_new;
	}
	/* now we create empty space */
	*(int*)noid_now = noid_size;
	noid_now += sizeof(int);

	//debug debug debug debug debug debug debug debug
	*(int*)noid_now = 0;
	*(int*)(noid_now + sizeof(int)) = 0;
	*(int*)(noid_now + sizeof(int)*2) = 0;
	//debug debug debug debug debug debug debug debug

	return noid_now;
}

void NOiD_free (NOiD_empty * noid_array, void * noid_old)
/*	step one free space chosen if not NULE	*/
/*	step two if there a free space next to the 	*/
/*	free space already declared result a merge of both	*/
/*	step three if there a free space back to the 	*/
/*	free space already declared result a merge of both	*/
{
	if (noid_old == NULE)
	{	return;		}
}

